%                          acheby.m
%
%    finds the nonuniform spacing that yields a Chebychev pattern
% 
% Antenna Arrays a Computational Approach
% Author: Randy L. Haupt
% 2010
% This program is only intended for demonstrations of book examples.
%


function amp=acheby(N,sll,d)

k=2*pi; nn=N/2;

m=2*nn-1;  %order of chebychev polynomial
ht=10^(sll/20);
z=1:nn;
t0=cosh((1/m)*acosh(ht));   %location of main beam
tz=cos((2*z-1)*pi/(2*m));
u0=2*acos(tz./t0)/k/d;

psiz=2*acos(tz/t0);
amp=[1 1];
for ic=1:nn-1
  amp=conv(amp,[1 -2*cos(psiz(ic)) 1]);
end
