% Chebychev distribution for planar array developed by
% Tseng and Cheng
% 
% Antenna Arrays a Computational Approach
% Author: Randy L. Haupt
% 2010
% This program is only intended for demonstrations of book examples.
%

function wt=tseng(Nx,slldb)
perm=inline('factorial(a)/factorial(b)/factorial(a-b)','a','b');
N=Nx/2; d=0.5; w0=cosh(1/(2*N-1)*acosh(10^(slldb/20)));
w=zeros(N,N);
for m=1:N
    for n=1:N
        if m>=n
            st=m;
        else
            st=n;
        end
        for s=st:N
            cc=(-1)^(N-s)*(2*N-1)/2/(N+s-1)*(w0/2)^(2*s-1);
            c1=perm(N+s-1,2*s-1);
            c2=perm(2*s-1,s-m);
            c3=perm(2*s-1,s-n);
            w(m,n)=w(m,n)+cc*c1*c2*c3;
        end
    end
end

wt=[fliplr(flipud(w)) flipud(w);fliplr(w) w];